% REDUCE script @(#)brownbasis.red  3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
ON COMP$ 
 
PROCEDURE BrownianBasis(BMList,BMInitialConditions)$ 
BEGIN 
   SCALAR BM1, dBM1, dBM2 $ 
   IF LENGTH BMList NEQ LENGTH BMInitialConditions 
      THEN REDERR "BrownianBasis: arguments differ in length." $ 
   FOR EACH BM IN BMList DO 
   BEGIN 
      dBM1 := MKID(d,BM) $ 
      Introduce(BM,dBM1) $ 
      END $ 
   FOR i:=1:LENGTH BMList DO 
   BEGIN 
      BM1 := PART(BMList,i) $ 
      dBM1 := d BM1 $ 
      LET dBM1**2 = dt $ 
      FOR j:=i+1:LENGTH BMList DO 
      BEGIN 
         dBM2 := d PART(BMList,j) $ 
         LET dBM1*dBM2 = 0 $ 
         END $ 
      Add!_Drift(dBM1,0) $ 
      Fixed(0,BM1) := PART(BMInitialConditions,i) $ 
      END  
   END $ 
 
OFF COMP $ 
$END$ 
 
