% REDUCE script @(#)bessel.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
OFF ECHO $ 
WRITE " 
Simple calculations involving Brownian motion and Bessel processes. 
=================================================================== 
"$ 
IN "itovsn3.red", "brown.red" $ 
 
WRITE " 
Introduce a three-dimensional Brownian motion  (A,B,C)  begun at the origin. 
"$  
Reset!_Ito() $ 
BrownianBasis({A,B,C},{0,0,0}) $ 
WRITE " 
------------------------------------------- 
Resulting second- and first-order structures, and initial values: 
" $ 
Status!_Ito()$ 
WRITE "------------------------------------------- 
 
Initial value at time  0  of  (A+1)**2*(B+2): "$ 
Initial!_Value(0,(A+1)**2*(B+2)); 
 
WRITE " 
Do it again, but begun at (1,2,3). 
 
------------------------------------------- 
Resulting second- and first-order structures, and initial values: 
" $ 
Reset!_Ito(); 
BrownianBasis({A,B,C},{1,2,3})$ 
Status!_Ito(); 
WRITE "------------------------------------------- 
 
Initial value at time  0  of  (A+1)**2*(B+2): "$ 
Initial!_Value(0,(A+1)**2*(B+2)); 
 
WRITE " 
Now we turn to the Bessel process  R  for Brownian motion in 3-space, built 
on the above processes  A, B, C."$ 
R := SQRT(A**2+B**2+C**2); 
WRITE " 
This has stochastic differential ",sd := d R$ 
 
WRITE " 
Check the second- and first-order structure is correct; should get two 
zeroes next." $ 
(sd **2) - dt; (Drift sd) - dt/R; 
 
WRITE " 
Initial value at time  0  of  R: ", Initial!_Value(0,R) $ 
 
WRITE " 
      End of output from  ex/bessel.red. 
      ================================== 
"$ 
 
END$ 
 
