% REDUCE script @(#)expmgl.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall.  
 
OFF ECHO$  
WRITE " 
      Examples of simple stochastic calculus. 
      ======================================= 
"$ 
IN "itovsn3.red" $ 
 
WRITE " 
Declare  a  as semimartingale and  da  as its stochastic differential."$ 
Introduce(a,da )$ 
 
WRITE " 
Impose second- and first-order structure making  a into a real-valued  
Brownian motion of zero drift. "$ 
LET da**2 = dt $        % Second-order structure: 
Add!_Drift(da,0) $      % First-order structure: 
WRITE " 
------------------------------------------- 
Current second- and first-order structures: 
" $ 
Status!_Ito() $ 
WRITE "------------------------------------------- 
"$ 
 
WRITE " 
The stochastic differential of ", a , " is ", d a $ 
WRITE "The stochastic differential of ", a**2 ," is ", d ( a**2 ) $ 
WRITE "The drift of ", da," is ", Drift d a $ 
 
WRITE " 
Consider the exponential martingale, ", 
   z := EXP( u*a - (1/2)*time*u**2 ) $ 
WRITE " 
It has stochastic differential         ", sd := d z $ 
WRITE " 
The differential is drift-free: ", drift!_sd := Drift sd $ 
 
WRITE " 
Now replace  u  by  f  which actually depends (previsibly) on  time, 
so we have to use  ItoIntegral:" $ 
DEPEND f,time $ 
WRITE v := EXP( ItoIntegral(f*da) - (1/2)*ItoIntegral(f**2*dt) ) $ 
WRITE " 
It has stochastic differential         ", sd := d v $ 
WRITE " 
The differential is drift-free: ", drift!_sd := Drift sd $ 
 
WRITE " 
Consider the martingale defined up to time  1  by the heat-kernel for  a. 
(We switch on the Greatest Common Denominator switch.)"$ 
ON GCD$ 
WRITE p := EXP(- a**2/(2*(1-time)))/SQRT(2*pi*(1-time)) $ 
WRITE " 
It has stochastic differential         ", sd := d p $ 
WRITE " 
The differential is drift-free: ", drift!_sd := Drift sd $ 
 
WRITE " 
      End of output from  ex/expmgl.red. 
      ================================== 
"$ 
END$ 
 
