% REDUCE script @(#)feller.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
ON COMP $  
 
PROCEDURE diffusion!_coefficients(X, dtau) $    % For  X  a diffusion (Dim=1) 
{ (1/2)*<<(d X)**2>>/dtau, (Drift d X)/dtau } $ % in the time-scale  dtau. 
 
PROCEDURE inf!_generator(y,a2,a1,x) $  % Infinitesimal generator: 
a2*DF(y,x,2) + a1*DF(y,x) $ %             Lf = a2*f'' + a1*f' 
 
PROCEDURE formal!_adjoint(y,a2,a1,x) $ % Formal adjoint: 
a2*DF(y,x,2) - DF(a1*y,x) $ %             L^*g = a2*g'' - (a1*g)'  
 
PROCEDURE scale!_gradient(a2,a1,x) $  
EXP( - INT( << a1/a2 >>, x) ) $ 
 
PROCEDURE scale!_function(a2,a1,x) $ % The non--constant harmonic function 
INT( scale!_gradient(a2,a1,x) ,x ) $ % for the diffusion. 
 
PROCEDURE speed!_density(a2,a1,x)  $ % The invariant density  
1/( a2*scale!_gradient(a2,a1,x) )  $ % for the diffusion. 
 
OFF COMP$ 
 
$END$ 
 
