% REDUCE script @(#)introduce.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
OPERATOR !_Drftbydt, !_Brktbydt $ 
 
PROCEDURE Introduce( x, dx ) $ 
   BEGIN 
   IF NOT FREEOF(Current!_Differentials,dx) THEN  
      REDERR "Attempt to re-introduce a stochastic differential" $ 
   DEPEND x,time $ DEPEND dx,time $ 
   LET DF(x,time)  = dx/!_!_dt!_temp $ LET DF(dx,time) = 0 $ 
   ItoIntegral(dx) := x - Fixed(0,x) $ 
   FOR EACH dy IN Current!_Differentials DO LET dx*dy = !_Brktbydt(dx,dy)*dt $ 
   LET dx*dt = 0, dx**2 = !_Brktbydt(dx,dx)*dt $ 
   Add!_Drift(dx, !_Drftbydt(dx)*dt) $ 
   Current!_Differentials   := dx.Current!_Differentials $ 
   Current!_Semimartingales :=  x.Current!_Semimartingales $ 
   IF Debug = 0 THEN BEGIN 
      WRITE "The variable ",x," has been declared a semimartingale" $ 
      WRITE "with corresponding stochastic differential ", dx 
      END $ 
   DEPEND x,RandomP $ DEPEND dx,RandomP $ 
   RETURN Current!_Differentials 
   END $ 
 
$END$ 
 
