% REDUCE script @(#)itosde.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
ON COMP$ 
 
% Itosde(X, (dX= ...), X0) introduces X, dX 
% and sets up second-order structure, initial 
% conditions appropriately. 
 
PROCEDURE Itosde(smgl, sde, initialconditions) $ 
BEGIN 
   SCALAR dsmgl, sd $ 
   dsmgl := LHS sde $ 
   sd := RHS sde $ 
   Introduce(smgl,dsmgl) $ 
   LET dsmgl**2 = sd**2 $ 
   FOR EACH dY IN Current!_Differentials DO 
      LET dsmgl*dY = sd*dY $ 
   Add!_Drift(dsmgl,Drift sd) $ 
   Fixed(0,smgl) := initialconditions $ 
   END $ 
 
OFF COMP $ 
$END$ 
 
