% REDUCE script @(#)reset.red   3.64,  
% copyright 6 June 1991, Wilfrid S. Kendall. 
 
PROCEDURE Reset!_Ito() $ 
BEGIN % FIRST clear previous structures. 
   FOR EACH dx IN Current!_Differentials DO 
   BEGIN 
      FOR EACH dy IN Current!_Differentials DO CLEAR dx*dy $ 
      Add!_Drift(dx, !_Drftbydt(dx)*dt) $ 
      NODEPEND dx, time $  
      CLEAR ItoIntegral(dx) $ 
      Add!_Drift(dx, !_Drftbydt(dx)*dt) $ 
      IF dx NEQ dt THEN 
      BEGIN 
         NODEPEND dx, RandomP $ 
         CLEAR DF(dx,time) $  
         END $ 
      END $ 
   FOR EACH x IN Current!_Semimartingales DO IF x NEQ time THEN 
   BEGIN 
      CLEAR DF(x,time) $ 
      NODEPEND x, RandomP $ 
      CLEAR Fixed(0,x) $ % May throw up error message if not defined! 
      END $ 
   % THEN establish most basic structure. 
   LET dt**2 = 0 $ 
   DEPEND dt, time $ 
   ItoIntegral(dt) := time $ 
   Add!_Drift(dt, dt) $ 
   Current!_Differentials := {dt} $ 
   Current!_Semimartingales := {time} 
   END$ 
 
PROCEDURE Status!_Ito() $ 
   BEGIN 
   WRITE "Current semimartingale differentials: " $ 
   WRITE Current!_Differentials $ 
   WRITE "Current second-order structure: " $ 
   FOR EACH dx IN Current!_Differentials DO WRITE "[for ",dx,"] ", 
      (FOR EACH dy IN Current!_Differentials COLLECT dx*dy) $ 
   WRITE "Current Drift substitutions: " $ 
   WRITE FOR EACH dx IN Current!_Differentials COLLECT (dx=Drift dx) $ 
   WRITE "Current Initial Value substitutions: " $ 
   WRITE FOR EACH x IN Current!_Semimartingales COLLECT (x=Fixed(0,x)) $ 
   END   $ 
 
$END$ 
 
